{ Arinc429 converter to Arinc407 JRV 09/2020 }

CON'Global
  _clkmode        = xtal1 + pll16x  'Standard clock mode * crystal frequency = 72 MHz
  _xinfreq        = glob#_XTAL_FREQ
  _uartfreq       = 115_200
  
VAR
  long uart_cog,tx_cog,rx_cog,gen_cog 
  long data_429T,lbl_429T
  long data_429R[256]
   
OBJ
  glob     : "A429to407_cst"                              ' globals constants
  pst      : "Parallax Serial Terminal_jrv"               ' Uart driver
  tx_429   : "A429_Transmiter"
  rx_429   : "A429_Receiver"
  gen_407  : "A407_Generator"
  'dbg     : "PASDebug"                                   ' for debug
PUB main
  uart_cog        := pst.Start(_uartfreq)            ' start serial terminal
  pause_ms(1000)
  tx_cog          := tx_429.start_429
  rx_cog          := rx_429.start_429(@data_429R)
  gen_cog         := gen_407.start_407
  lbl_429T        := $AA
  data_429T       := 0
  pst.dec(uart_cog)
  pst.comma
  pst.dec(tx_cog)
  pst.comma
  pst.dec(rx_cog)
  pst.comma
  pst.dec(gen_cog)
  pst.newline
   
  repeat
      tx_429.xmit_429($8000_0000|(data_429T<<8) | (lbl_429T & $FF))
      pst.dec(data_429T)
      data_429T := (data_429T+1)& $FFFF
      pause_ms(5)
       if (lbl_429T & $FF) == $AA
          gen_407.wdat_407(data_429R[lbl_429T & $FF])
      data_429R[lbl_429T & $FF]:= 0
      pst.comma
      data_429R[0]:= gen_407.rdat_407
      pst.dec(data_429R[0])
      pst.newline
      pause_ms(50)
      
      
PRI pause_ms(mS)| clkcycles
  clkcycles := ((clkfreq /1000 * mS ) - 4296) #> 381     ' Calculate 1 ms time unit
  waitcnt(clkcycles + cnt)                                ' Wait for designated time
  