{Arin407 generator , input is angle value on 16 bits
 SPI Smessage is [A1,A0,C1,C0,D11....D0] msb first }

CON
  ' from MA537 datasheet
  _REG0       = %00_01                            ' load DAC0 register
  _REG1       = %01_01                            ' load DAC1 register
  _REG2       = %10_01                            ' load DAC2 register
  _REG3       = %11_01                            ' load DAC3 register
  _RUP0       = %00_11                            ' load DAC0 register ,update all dacs
  _RUP1       = %01_11                            ' load DAC1 register ,update all dacs
  _RUP2       = %10_11                            ' load DAC2 register ,update all dacs
  _RUP3       = %11_11                            ' load DAC3 register ,update all dacs
  _LALL       = %00_00                            ' Load all dacs registers from data 
  _NOPE       = %11_00                            ' Nop
  _UPHI       = %11_10                            ' Update SDO rising edge
  _UPLO       = %11_10                            ' Update SDO falling edge
  _BIT_407    = 12                                ' number of bit for SPI to DAC
  _FREQ_407   = 500_000                           ' SPI  frequency
  _TIME_407   = (glob#_XTAL_FREQ *16)/_FREQ_407   ' SPI period
VAR
  long  A407G_cog,A407G_data[2]
   
OBJ
  glob     : "A429to407_cst"                              ' globals constants

  'dbg     : "PASDebug"
PUB start_407
  A407G_data  := 0
  A407G_cog   := (cognew(@A407G_entry,@A407G_data)+1) 'start A407 generator
return A407G_cog
PUB wdat_407(data)
  repeat while (A407G_data[0] <> 0)
  A407G_data[0]  := $8000_0000|data  'set data & flag
PUB rdat_407
  return A407G_data[1]
DAT
org
entry
'-- Debugger Kernel add this at Entry (Addr 0)
   'long $34FC1202,$6CE81201,$83C120B,$8BC0E0A,$E87C0E03,$8BC0E0A
   'long $EC7C0E05,$A0BC1207,$5C7C0003,$5C7C0003,$7FFC,$7FF8

A407G_entry       mov     adr_data,par                    ' data address
                  mov     adr_sin,par
                  add     adr_sin,#4
                  mov     dval,mid_val                     
                  wrlong  dval,adr_data                   ' init value to lock input
                  or      outa,csn_mask                   ' set csn to 1
                  or      dira,out_mask                   ' activate outputs
tst               mov     dval,#_LALL                     ' set command to load all dacs with mid val
                  shl     dval,#_BIT_407-4                 ' shift to rigth place
                  or      dval,mid_val
                  call    #xmit                           ' return with dval = 0
                  mov     dval,#_UPHI                     ' set command to update all dacs
                  shl     dval,#_BIT_407-4                   ' shift to rigth place
                  call    #xmit                           ' return with dval = 0
                  wrlong  dval,adr_data                   ' init value to zero <=> init done
{----------------------------------------------------------------------------------------------}


wait_data         mov     cval,ina                        ' wait for CSn falling
                  test    cval,ref_mask           wc      ' mask unused bits
                  rcl     refin,#1
                  mov     eval,refin
                  and     eval,#$F
                  cmp     eval,#8                 wz      ' wait for eval = %1000 falling edge of Ref400 
  if_nz           jmp     #wait_data
                  rdlong  dval,adr_data          wz       ' read angle
  if_z            jmp     #wait_data                      ' wait for non zero value
                  shr     dval,#3                         ' reduce 16 bits to 13
                  and     dval,data_mask                  ' remove flag
                  mov     eval,dval                       ' save
                  call    #get_sin                        ' return offset binary 0(-1) to $FFF(+1)
                  wrlong  dval,adr_sin
                  mov     cval,#_REG0
                  shl     cval,#_BIT_407-4
                  or      dval,cval
                  call    #xmit                           ' send reg0 value = sin(angle)
                  mov     dval,eval
                  add     dval,deg_120
                  call    #get_sin                        ' return offset binary 0(-1) to $FFF(+1) 
                  mov     cval,#_REG1
                  shl     cval,#_BIT_407-4
                  or      dval,cval
                  call    #xmit                           ' send reg1 value = sin(angle+120)
                  mov     dval,eval
                  add     dval,deg_240
                  call    #get_sin                        ' return offset binary 0(-1) to $FFF(+1) 
                  mov     cval,#_REG2
                  shl     cval,#_BIT_407-4
                  or      dval,cval
                  call    #xmit                           ' send reg2 value = sin(angle+240)
                  mov     dval,#_UPHI                     ' set command to update all dacs
                  shl     dval,#_BIT_407-4                        ' shift to rigth place
                  call    #xmit                           ' return with dval = 0
                  wrlong  dval,adr_data                   ' ack to caller
                  jmp     #wait_data
                  
{----------------------------------------------------------------------------------------------}
                  
xmit              mov     cval,#_BIT_407                  ' load bit count
                  shl     dval,#16+16-_BIT_407            ' move data to top of register
                  andn    outa,csn_mask                   ' set csn to 0
xmit_loop         shl     dval,#1                  wc     ' read msb        
                  muxc    outa,dat_mask                   ' set output      
                  mov     time0,#_TIME_407/4              '                 
                  sub     time0,#31
                  call    #delay                          '                 
                  or      outa,sck_mask                   ' sck rising edge 
                  mov     time0,#_TIME_407/2
                  sub     time0,#24
                  call    #delay
                  andn    outa,sck_mask                   ' sck falling edge
                  mov     time0,#_TIME_407/4
                  sub     time0,#28
                  call    #delay
                  djnz    cval,#xmit_loop                 ' dec bit count
                  or      outa,csn_mask                   ' set csn to 1
                  mov     time0,#_TIME_407
                  call    #delay
xmit_ret          ret
{----------------------------------------------------------------------------------------------}

get_sin           and     dval,data_mask                   ' mask upper bits
                  test    dval,sin_90              wc      ' get quadrant 2|4 into c 
                  test    dval,sin_180             wz      ' get quadrant 3|4 into nz 
                  negc    dval,dval                        ' if quadrant 2|4, negate offset 
                  or      dval,sin_table                   ' or in sin table address >> 1 
                  shl     dval,#1                          ' shift left to get final word address 
                  rdword  dval,dval                        ' read word sample from $E000 to $F000 
                  negnz   dval,dval                        ' if quadrant 3|4, negate sample
                  sar     dval,#5+16-_BIT_407              ' map on 8 or 12 bits
                  xor     dval,offset_bin                  ' convert to offset binary
                  and     dval,sin_mask
get_sin_ret       ret
{----------------------------------------------------------------------------------------------}

delay             add     time0,cnt                       'delay routine
                  waitcnt time0,#0                        '             
delay_ret         ret                                     '             

{-------------------------------------Variables and Constants-----------------------------------}

sck_mask          long    1 << glob#_SCKO
dat_mask          long    1 << glob#_DATAO
csn_mask          long    1 << glob#_CSNO
mid_val           long    $400 >> (16-_BIT_407)' Dacs mid scale 
out_mask          long    1 << glob#_SCKO | 1 << glob#_DATAO|1 << glob#_CSNO ' output activation
ref_mask          long    1 << glob#_REF400'400Hz reference signal
data_mask         long    $1FFF ' mask to process angle
sin_90            long    $0800  
sin_180           long    $1000 
sin_table         long    $E000 >> 1 'sine table base address shifted right                                      
offset_bin        long    $800 >> (16-_BIT_407)       ' to convert 2's complement in offet binary
sin_mask          long    $FFF >> (16-_BIT_407)
deg_120           long    $0C00
deg_240           long    $1400

adr_data          res     1  ' adress of data
adr_sin           res     1
time0             res     1  ' register for timing
refin             res     1  ' 400 Hz detect reg
cval              res     1  ' temporary registers
dval              res     1
eval              res     1
fval              res     1
FIT      