{Arin429 emulator}
CON
  _BIT_429        = 32                                ' number of bits per word
  _LBL_429        = 8                                 ' number of bit for label

VAR
  long  A429R_cog,A429R_data,rcv_data
   
OBJ
  glob     : "A429to407_cst"                              ' globals constants

  'dbg     : "PASDebug"
PUB start_429(addr)
  A429R_data  := addr
  A429R_cog   := (cognew(@A429R_entry,A429R_data)+1) 'start A429 transmitter
return A429R_cog

PUB rcvr_429
  'repeat while (A429R_data == 0)
  rcv_data := A429R_data
  A429R_data  := 0
 return  rcv_data 

DAT
org
entry
'-- Debugger Kernel add this at Entry (Addr 0)
   'long $34FC1202,$6CE81201,$83C120B,$8BC0E0A,$E87C0E03,$8BC0E0A
   'long $EC7C0E05,$A0BC1207,$5C7C0003,$5C7C0003,$7FFC,$7FF8

A429R_entry       mov     adr_data,par                    ' data address
                  mov     csin,data_mask
                  mov     ckin,data_mask
                  mov     dira,tst_mask
                  mov     dval,#0
                  mov     cval,#256
init_buff         wrlong  dval,adr_data                   ' init value to zero    
                  djnz    cval,#init_buff
wait_data         mov     dval,#0
                  mov     fval,#_BIT_429                  ' load bit count
wait_csn          mov     cval,ina                        ' wait for CSn falling
                  test    cval,csn_mask           wc      ' mask unused bits
                  rcl     csin,#1
                  mov     eval,csin
                  and     eval,#$F
                  cmp     eval,#8                 wz      ' wait for eval = %1000 falling edge of CSn 
  if_nz           jmp     #wait_csn
wait_sck_lo       mov     cval,ina                        ' wait for SCK falling                  
                  test    cval,csn_mask           wc
  if_c            jmp     #wait_data                      ' CSn released abort
                  test    cval,sck_mask           wc      ' mask unused bits
                  rcl     ckin,#1
                  mov     eval,ckin
                  and     eval,#$F
                  cmp     eval,#8                 wz      ' wait for eval = %1000 falling edge of SCK 
  if_nz           jmp     #wait_sck_lo
                  test    cval,dat_mask           wc      ' mask unused bits  
                  rcr     dval,#1                         ' shift in data
                  djnz    fval,#wait_sck_hi               ' not finished
                  test    dval,data_mask           wc         ' check parity
  if_nc           jmp     #wait_data                      ' parity error ignore value
                  mov     eval,dval                       ' copy for label inversion
                  rev     eval,#32-_LBL_429               ' reverse bit order of label
                  shl     eval,#2                         ' and compute pointer in table
                  add     eval,adr_data
                  wrlong  dval,eval                       ' done
                  jmp     #wait_data
wait_sck_hi       mov     cval,ina                        ' wait for SCK rising
                  test    cval,csn_mask         wc
  if_c            jmp     #wait_data                      ' CSn released abort
                  test    cval,sck_mask         wc        ' mask unused bits
                  rcl     ckin,#1
                  mov     eval,ckin
                  and     eval,#$F
                  cmp     eval,#7               wz        ' wait for eval = %0111 rising edge of SCK 
  if_nz           jmp     #wait_sck_hi
                  jmp     #wait_sck_lo
                  
                  
{----------------------------------------------------------------------------------------------}

delay             add     time0,cnt                        'delay routine
                  waitcnt time0,#0
delay_ret         ret

{-------------------------------------Variables and Constants-----------------------------------}

sck_mask          long    1 << glob#_SCKI
dat_mask          long    1 << glob#_DATAI 
csn_mask          long    1 << glob#_CSNI
ina_mask          long    1 << glob#_SCKI|1 << glob#_CSNI
tst_mask          long    1 << glob#_RES12
data_mask         long    $FFFF_FFFF ' mask to process data parity
adr_data          res     1  ' adress of data
time0             res     1  ' register for timing
csin              res     1
ckin              res     1

cval              res     1  ' temporary registers
dval              res     1
eval              res     1
fval              res     1
FIT      