{Arin429 emulator}
CON
  _FREQ_429       = 12_500                            ' Arinc 429 frequency
  _TIME_429       = (glob#_XTAL_FREQ *16)/_FREQ_429   ' Arinc 429 period
  _BIT_429        = 32                                ' number of bits per word
  _LBL_429        = 8                                 ' number of bit for label
  _GAP_429        = 4                                 ' gap betwwen words

VAR
  long  A429T_cog,A429T_data
   
OBJ
  glob     : "A429to407_cst"                              ' globals constants

  'dbg     : "PASDebug"
PUB start_429
  A429T_data  := 0
  A429T_cog   := (cognew(@A429T_entry,@A429T_data)+1) 'start A429 transmitter
return A429T_cog
PUB xmit_429(data)
  repeat while (A429T_data <> 0)
  A429T_data  := data

DAT
org
entry
'-- Debugger Kernel add this at Entry (Addr 0)
   'long $34FC1202,$6CE81201,$83C120B,$8BC0E0A,$E87C0E03,$8BC0E0A
   'long $EC7C0E05,$A0BC1207,$5C7C0003,$5C7C0003,$7FFC,$7FF8

A429T_entry       mov     adr_data,par                    ' data address
                  mov     dval,#0     
                  wrlong  dval,adr_data                   ' init value to zero
                  or      outa,out_mask                   ' set outa to "11"
                  or      dira,out_mask                   ' activate outputs
wait_data         rdlong  dval,adr_data          wz
  if_z            jmp     #wait_data                      ' wait for non zero value
                  and     dval,data_mask          wc      ' compute parity
  if_nc           or      dval,par_mask                   ' add parity bit
                  mov     eval,dval                       ' copy for label inversion
                  rev     eval,#32-_LBL_429               ' reverse bit order
                  andn    dval,#$FF                       ' mask lower byte
                  or      dval,eval                       ' replace
                  mov     cval,#_GAP_429                  ' gap duration
make_gap          mov     time0,fbit_time                 ' create gap
                  call    #delay
                  djnz    cval,#make_gap
                  mov     cval,#_BIT_429                  ' load bit count
xmit_shift        mov     time0,hbit_time                 ' half bit time 
                  shr     dval,#1                 wc      ' get bit value
  if_c            mov     outa,one_mask                   ' set outa to "01"
  if_nc           mov     outa,zero_mask                  ' set outa to "10"
                  call    #delay                          
                  mov     outa,#0                         ' set outa to "00"
                  mov     time0,hbit_time 
                  call    #delay
                  djnz    cval,#xmit_shift                ' decrement and check xmit end
                  mov     outa,#0                         ' set outa to "00"
                  wrlong  dval,adr_data                   ' send ack
                  jmp     #wait_data                      ' ready for next
{----------------------------------------------------------------------------------------------}

delay             add     time0,cnt                                'delay routine
                  waitcnt time0,#0
delay_ret         ret

{-------------------------------------Variables and Constant-----------------------------------}

one_mask          long    1 << glob#_A429TA
zero_mask         long    1 << glob#_A429TB 
out_mask          long    1 << glob#_A429TA| 1 << glob#_A429TB ' output activation
data_mask         long    $7FFF_FFFF ' mask to process data parity
par_mask          long    $8000_0000 ' parity bit
fbit_time         long    _TIME_429  ' full bit time
hbit_time         long    _TIME_429/2 ' half bit time
adr_data          res     1  ' adress of data
time0             res     1  ' register for timing
cval              res     1  ' temporary registers
dval              res     1
eval              res     1
fval              res     1
FIT      